<template>
  <q-form ref="formRef" @submit="() => handleNextFormSectionRequested('next')">
    <h5 class="q-my-sm schedule-header">{{ $t("schedule_session.section_3.title") }}</h5>

    <h6 :class="[hasCapacity ? '': 'noCapacity', 'q-my-sm']">{{ $t("schedule_session.section_3.added_participants", [Object.keys(newParticipants).length,capacity]) }}</h6>
    <ManageParticipantsList :participants="newParticipants" :requestDelete="handleRequestDeleteParticipant"
      :requestToggleModerator="handleRequestToggleModerator" :usersPhone="hostNum" :trunk="trunk"/>

    <div class="q-my-md text-center" v-if="Object.keys(newParticipants).length == 0">
      {{ $t("schedule_session.section_4.no_participants") }}
    </div>

    <q-separator inset class="q-mb-lg q-mt-sm" />

    <div style="width: 230px; margin:auto; text-align: center;">
      <q-btn color="primary" rounded :disable="!hasCapacity" icon-right="dialpad" @click="() => showAddFromNumberDialog = true">
        {{ $t(`invite_arbitrary_number.add_from_number`) }}&nbsp;
      </q-btn>
    </div>

    <q-dialog v-model="showAddFromNumberDialog">
      <q-card style="min-width:33%">
        <q-card-section class="q-pb-none">
          <h6 class="q-my-sm">{{ $t("invite_arbitrary_number.add_from_number") }}</h6>
          <InviteArbitraryNumber :participants="newParticipants" :usersPhone="hostNum" :offerAddContact="true"
            :inviteParticipant="
            (phoneNumber, newParticipant, addContact) =>
            {
              const copyNewParticipants = { ...newParticipants };
              copyNewParticipants[phoneNumber] = newParticipant;
              newParticipants = copyNewParticipants;
              if (addContact)
              {
                handleNewContact(phoneNumber, newParticipant)
              }
              showAddFromNumberDialog = false;
            }" />
        </q-card-section>
      </q-card>
    </q-dialog>

    <h6 class="q-my-sm">{{ $t("schedule_session.section_3.groups_header") }}</h6>

    <div class="invite-groups">
      <q-list separator style="margin-bottom:40px;" v-if="selectedGroups && Object.keys(selectedGroups).length > 0">
        <q-item v-for="(group, groupName) in selectedGroups" :key="groupName" class="q-px-none" :clickable="canAddGroup(groupName)" v-ripple
          @click.stop="() => handleRequestGroupInvite(groupName, !selectedGroups[groupName].Selected)">
          <q-item-section side v-if="selectedGroups && selectedGroups[groupName]">
            <q-checkbox :disable="!selectedGroups[groupName].Selected && !canAddGroup(groupName)" v-model="selectedGroups[groupName].Selected"
              @input="(newValue) => handleRequestGroupInvite(groupName, newValue)" />
          </q-item-section>
          <q-item-section>
            <q-item-label>
              {{ groupName }}
            </q-item-label>
            <q-item-label caption>
              {{ group.MemberString }}
            </q-item-label>
          </q-item-section>
        </q-item>
      </q-list>
      <div class="q-ma-lg" v-else>
        {{ $t("contacts.groups_list_empty") }}
      </div>
    </div>

    <h6 class="q-my-sm">{{ $t("schedule_session.section_3.contacts_header") }}</h6>

    <InviteFromContacts :toInvite="newParticipants" :setToInvite="handleSetToInvite" :contacts="contacts"
      :hostNumber="hostNum" :canInvite="hasCapacity" :hideSelected="true" />
    <q-page-sticky position="bottom-left">
      <q-btn class="q-ma-sm" @click="() => handleNextFormSectionRequested('prev')" fab color="primary">
        <q-icon name="chevron_left" />
        <div class="q-pr-sm">{{ $t("schedule_session.prev") }}</div>
      </q-btn>
    </q-page-sticky>

    <q-page-sticky position="bottom-right">
      <q-btn type="submit" fab color="primary" class="q-ma-sm">
        <div class="q-pl-sm">{{ $t("schedule_session.next") }}</div>
        <q-icon name="chevron_right" />
      </q-btn>
    </q-page-sticky>
  </q-form>
</template>
<script>
import { validPhoneNumber } from "../utils/phone";
import InviteFromContacts from "./InviteFromContacts.vue";
import InviteArbitraryNumber from "./InviteArbitraryNumber.vue";
import ManageParticipantsList from "./ManageParticipantsList.vue";
import Vue from "vue";
import { functions } from "../firebase";

export default {
  data()
  {
    return {
      newParticipants: { ...this.participants },
      selectedGroups: null,
      showAddFromNumberDialog: false
    };
  },
  props: {
    requestSaveFormSection: {
      required: true
    },
    groups: { required: true },
    contacts: { required: true },
    participants: { required: true },
    hostNum: { required: true },
    capacity: { required: true },
    trunk: { required: true}
  },
  mounted()
  {
    let toRet = {};
    for (const groupName in this.groups) 
    {
      let members = [];
      for (const num in this.groups[groupName].Members) 
      {
        members.push(this.contacts[num].Name);
      }

      toRet[groupName] = {
        ...{
          'MemberString': members.join(", "),
          'Selected': false
        },
        ...this.groups[groupName]
      };
    }

    this.selectedGroups = toRet;
  },
  computed:
  {
    remainingCapacity()
    {
      return this.capacity - Object.keys(this.newParticipants).length;
    },
    hasCapacity()
    {
      return this.remainingCapacity > 0;
    }
  },
  methods: {
    canAddGroup(groupName)
    {
      return this.remainingCapacity >= Object.keys(this.groups[groupName].Members).length
    },
    handleRequestGroupInvite(groupName, selected) 
    {
      this.selectedGroups[groupName].Selected = selected;

      for (const member in this.selectedGroups[groupName].Members) 
      {
        if (selected && this.newParticipants[member] == undefined)
        {
          this.newParticipants = {
            ...this.newParticipants,
            ...{
              [member]: {
                ...this.contacts[member],
                ...{
                  'Moderator': this.selectedGroups[groupName].Members[member]
                }
              }
            }
          }
        }
        else if (!selected)
        {
          this.$delete(this.newParticipants, member);
        }
      }
    },
    handleNextFormSectionRequested(direction) 
    {
      this.requestSaveFormSection(direction, this.newParticipants);
    },
    handleSetToInvite(toInvite, phoneNumber, selected) 
    {
      this.newParticipants = toInvite;

      if (!selected)
      {
        for (const groupName in this.selectedGroups) 
        {
          if (this.selectedGroups[groupName].Members[phoneNumber] != null)
          {
            this.selectedGroups[groupName].Selected = false;
          }
        }
      }
    },
    validPhoneNumberRule(val)
    {
      return validPhoneNumber(this.phoneCode.value.code, val);
    },
    handleRequestToggleModerator(phoneNumber)
    {
      if ((this.newParticipants[phoneNumber] || {}).Moderator == undefined)
        return;
      this.newParticipants[phoneNumber].Moderator = !this.newParticipants[
        phoneNumber
      ].Moderator;
    },
    handleRequestDeleteParticipant(phoneNumber)
    {
      Vue.delete(this.newParticipants, phoneNumber);
      this.handleSetToInvite(this.newParticipants, phoneNumber, false)
    },
    async handleNewContact(phoneNumber, participant)
    {
      const createContactFb = functions.httpsCallable("createContact");
      this.$q.loading.show();
      await createContactFb({
        Name: participant.Name,
        Number: phoneNumber,
      });
      this.$q.loading.hide();
    },
  },
  components: {
    InviteFromContacts,
    ManageParticipantsList,
    InviteArbitraryNumber,
  },
};
</script>
<style scoped>
.noCapacity {
  color: red;
}
</style>